global function placeColonyObjects

struct
{
    entity nessy
}
file


void function placeColonyObjects()
{
    PrecacheModel( $"models/communication/terminal_com_station_tall.mdl" )

    entity button = CreateSimpleButton( <405.671, 115.202, 1039.96> + <0,10,-4>, <0, 0, 30>, "to spawn a dropship", callback_dropShipButtonTriggered )
    CreateSimpleButton( <405.671, 115.202, 1039.96> + < -50,10,-4 >, <0, 0, 30>, "to show the Nessy", callback_NessyButtonTriggered )

    CreateNessy( < -930, -8577, 279 >, <0, 60, 0>, 9 )
    
    entity pole = CreateEntity( "prop_dynamic_lightweight" )
	pole.SetValueForModelKey( $"models/communication/terminal_com_station_tall.mdl" )
	pole.kv.fadedist = 10000
	pole.kv.renderamt = 255
	pole.kv.rendercolor = "255 255 255"
    pole.kv.modelscale = 5
	pole.kv.solid = SOLID_VPHYSICS // 0 = no collision, 2 = bounding box, 6 = use vPhysics, 8 = hitboxes only
    pole.SetOrigin( < -574, -8255, 321 > )
    pole.SetAngles( CONVOYDIR )
    DispatchSpawn( pole )

    if ( !GetConVarBool( "dropships_enabled" ) )
        return

    file.nessy = CreatePropDynamic( $"models/domestic/nessy_doll.mdl", button.GetOrigin() + <0,30,0>, <0,180,0>, SOLID_VPHYSICS )
    file.nessy.SetUsableByGroup( "pilot" )
    string message = "The tower is on a cooldown. Try !dropship in the chat <3."
    file.nessy.SetUsePrompts( message, message )
    file.nessy.UnsetUsable()
}

void function callback_dropShipButtonTriggered( entity button, entity player )
{
    if ( GetEntArrayByScriptName( "drivable_dropship" ).len() > 10 )
		return
    
    if ( !GetConVarBool( "dropships_enabled" ) || !IsValid( file.nessy ) )
    {
        Chat_ServerPrivateMessage( player, "dropships are disabled by host", false )
		return
    }

    foreach ( entity ent in GetEntArrayByScriptName( "drivable_dropship" ) )
    {
        if ( Distance2D( ent.GetOrigin(), button.GetOrigin() ) < 1000 )
            return
    }

    #if DROPSHIP_MOD
        file.nessy.SetUsable()

        vector origin = button.GetOrigin()
        DropShiptruct dropship = SpawnDrivableDropShip( origin + <0,10000,10000>, <0,-90,0>, player.GetTeam() )
        entity mover = dropship.dropship.mover
        
        mover.NonPhysicsMoveTo( origin + <0,500,0>, 6, 0.1, 1 )
        
        thread TurnOffNessyMessage()
    #else
        print("cat_or_not.DropshipDrivable isn't installed >:(")
    #endif
}

void function TurnOffNessyMessage()
{
    wait 30
    file.nessy.UnsetUsable()
}

void function callback_NessyButtonTriggered( entity button, entity player )
{
    array<entity> Nessy = GetEntArrayByScriptName( "Nessy" )

    if ( Nessy.len() == 0 )
        return
    
    player.SetAngles( <0,-103,0> )

    Chat_ServerPrivateMessage( player, "Nessy is somewhere over there ( you might need a dropship to get there )", false )
}